Bspf
Date: 2019-10-22

org.jmol.bspt

## Class Bspf

- java.lang.Object
- - org.jmol.bspt.Bspf

-     public final class Bspf
      extends java.lang.Object

  A Binary Space Partitioning Forest

  This is simply an array of Binary Space Partitioning Trees identified by indexes

  Author:
    Miguel, miguel@jmol.org

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `Bspt[]` | `bspts`
    `(package private) boolean[]` | `bsptsValid`
    `(package private) CubeIterator[]` | `cubeIterators`
    `(package private) int` | `dimMax`
    `boolean` | `isValid`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Bspf(int dimMax)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addTuple(int bsptIndex, javajs.util.P3 tuple)`
    `CubeIterator` | `getCubeIterator(int bsptIndex)`
    `CubeIterator` | `getNewCubeIterator(int bsptIndex)`
    `void` | `initialize(int modelIndex, javajs.util.P3[] atoms, javajs.util.BS modelAtomBitSet)`
    `boolean` | `isInitializedIndex(int bsptIndex)`
    `void` | `stats()`
    `void` | `validateModel(int i, boolean isValid)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### dimMax

          int dimMax

    - #### bspts

          public Bspt[] bspts

    - #### isValid

          public boolean isValid

    - #### bsptsValid

          boolean[] bsptsValid

    - #### cubeIterators

          CubeIterator[] cubeIterators

  - ### Constructor Detail

    - #### Bspf

          public Bspf(int dimMax)

  - ### Method Detail

    - #### validateModel

          public void validateModel(int i,
                                    boolean isValid)

    - #### isInitializedIndex

          public boolean isInitializedIndex(int bsptIndex)

    - #### addTuple

          public void addTuple(int bsptIndex,
                               javajs.util.P3 tuple)

    - #### stats

          public void stats()

    - #### getCubeIterator

          public CubeIterator getCubeIterator(int bsptIndex)

      Parameters:
        `bsptIndex` - a model index
      Returns:
        either a cached or a new CubeIterator

    - #### getNewCubeIterator

          public CubeIterator getNewCubeIterator(int bsptIndex)

    - #### initialize

          public void initialize(int modelIndex,
                                 javajs.util.P3[] atoms,
                                 javajs.util.BS modelAtomBitSet)